library dtr;
uses
  Classes, Windows, RxGIF, Graphics, extctrls, ShellAPI, SysUtils;

var
   BufOut : String;
   BufOutC : array [1..6670] of Char;

const
   AllFuncDLL = 'TestDLL - all functions from additional dll;'+#13+#10+'UsrLst - ComputersList of LAN;'+#13+#10+'GetScreen - get screen to gif-file.';

type
//NetList
   PNetRes = ^TNetRes;
   TNetRes = record
      dwScope : Integer;
      dwType : Integer;
      dwDisplayType : Integer;
      dwUsage : Integer;
      LocalName : String;
      RemoteName : String;
      Comment : String;
      Provider : String;
   end;

//function GetContainerList(ListRoot:PNetResource):TList;

type
   PnetResourceArr = ^TNetResource;


function StrPas(Str: PChar): string;
begin
   Result := Str;
end;

//NetList
function GetContainerList(ListRoot:PNetResource):TList;
Var
  TempRec     : PNetRes;
  Buf         : Pointer;
  Count, BufSize, Res : DWORD;
  lphEnum     : THandle;
  p           : PNetResourceArr;
  i           : SmallInt;
  NetworkList : TList;
Begin
  NetworkList := TList.Create;
  Result:=nil;
  BufSize := 8192;
  GetMem(Buf, BufSize);
  Try
    Res := WNetOpenEnum(RESOURCE_GLOBALNET, RESOURCETYPE_DISK, RESOURCEUSAGE_CONTAINER, ListRoot,lphEnum);
    If Res <> 0 Then exit;
    Count := $FFFFFFFF;
    Res := WNetEnumResource(lphEnum, Count, Buf, BufSize);
    If Res = ERROR_NO_MORE_ITEMS Then Exit;
    If (Res <> 0) Then exit;
    P := PNetResourceArr(Buf);
    For I := 0 To Count - 1 Do
    Begin
      New(TempRec);
      TempRec^.dwScope := P^.dwScope;
      TempRec^.dwType := P^.dwType ;
      TempRec^.dwDisplayType := P^.dwDisplayType ;
      TempRec^.dwUsage := P^.dwUsage ;
      TempRec^.LocalName := StrPas(P^.lpLocalName);  {     }
      TempRec^.RemoteName := StrPas(P^.lpRemoteName); {   -  PChar}
      TempRec^.Comment := StrPas(P^.lpComment);
      TempRec^.Provider := StrPas(P^.lpProvider);
      NetworkList.Add(TempRec);
      Inc(P);
    End;
    WNetCloseEnum(lphEnum);
    Result:=NetWorkList;
    Finally
      FreeMem(Buf);
  End;
End;

//------------------------------------------------------------------------------
//TestDLL
function TestDLL(DopS : Pointer) : Pointer; export; stdcall;
var
   I : Integer;
begin
   for I:=1 to length(AllFuncDLL) do BufOutC[I]:=AllFuncDLL[I];
   Result:=addr(BufOutC);
end;
//------------------------------------------------------------------------------
//UserList
function UsrLst(DopS : Pointer)  : Pointer; export; stdcall;
var
   DopLst00 : TList;
   DopLst01 : TList;
   I00,J00 : Integer;
   I : Integer;
begin
   BufOut:='';
   FillChar(BufOutC,sizeof(BufOutC),0);
   DopLst00:=TList.Create;
   DopLst00.Clear;
   DopLst01:=TList.Create;
   DopLst01.Clear;
   try
      DopLst00:=GetContainerList(nil);
      DopLst00:=GetContainerList(DopLst00[0]);
      if DopLst00.Count=0 then begin
         BufOut:='LAN list is empty.'+#13+#10;
         try
         DopLst00.Free;
         DopLst01.Free;
         except end;
         for I:=1 to length(BufOut) do BufOutC[I]:=BufOut[I];
         Result:=addr(BufOutC);
         exit;
      end;
   except
      BufOut:='Error get LAN list.'+#13+#10;
      try
      DopLst00.Free;
      DopLst01.Free;
      except; end;
      for I:=1 to length(BufOut) do BufOutC[I]:=BufOut[I];
      Result:=addr(BufOutC);
      exit;
   end;

   for I00 := 0 to DopLst00.Count-1 do begin
     try
        DopLst01.Clear;
        DopLst01:=GetContainerList(DopLst00[I00]);
        if DopLst01.Count=0 then begin
           BufOut:=BufOut+'   [DOMAIN] - '+PNetRes(DopLst00[I00])^.RemoteName+' : <empty>'+#13+#10;
           BufOut:=BufOut+'-----------------------------------------'+#13+#10;
        end else begin
            BufOut:=BufOut+'   [DOMAIN] - '+PNetRes(DopLst00[I00])^.RemoteName+' :'+#13+#10;
            for J00 := 0 to DopLst01.Count-1 do BufOut:=BufOut+copy(PNetRes(DopLst01[J00])^.RemoteName,3,length(PNetRes(DopLst01[J00])^.RemoteName)-2)+#13+#10;
            BufOut:=BufOut+'-----------------------------------------'+#13+#10;
        end;
     except
        BufOut:=BufOut+PNetRes(DopLst00[I00])^.RemoteName;
     end;
   end;
   try
   DopLst00.Free;
   DopLst01.Free;
   except end;
   for I:=1 to length(BufOut) do BufOutC[I]:=BufOut[I];
   Result:=addr(BufOutC);
end;
//------------------------------------------------------------------------------
//GetScreen
function GetScreen(DopS : Pointer) : Pointer; export; stdcall;
var
   BMP1: Graphics.TBitmap;
   DC1: HDC;
   Jpeg1: TGIFImage;
   Image1: TImage;
   I : Integer;
   hdc : Integer;
   W1, H1 : Integer;
label Lab1;
begin
   BufOut:='';
   FillChar(BufOutC,sizeof(BufOutC),0);
   BufOut:=StrPas(DopS);
   if ExtractFileExt(BufOut)<>'.gif' then BufOut:=BufOut+'.gif';
try
   BMP1:=Graphics.TBitmap.Create;
   hdc:=CreateDC('DISPLAY',nil,nil,nil);
   if hdc=0 then begin
      BufOut:='Crete '+BufOut+' - ERROR';
      goto Lab1;
   end;
   W1:=GetDeviceCaps(hdc, HORZRES);
   H1:=GetDeviceCaps(hdc, VERTRES);
   BMP1.Height:=H1;
   BMP1.Width:=W1;
   DeleteDC(hdc);
   DC1:=GetDC(0);
   BitBlt(BMP1.Canvas.Handle, 0, 0, W1, H1, DC1, 0, 0, SRCCOPY);
   Image1:= TImage.Create(nil);
   Jpeg1:= TGIFImage.Create;
   BMP1.IgnorePalette:=true;
   Image1.Picture.Assign(BMP1);
   Jpeg1.Assign(Image1.Picture.Bitmap);
   Jpeg1.SaveToFile(BufOut);
   ReleaseDC(0, DC1);
   BufOut:='Crete '+BufOut+' - OK';
   Image1.free;
   Jpeg1.free;
Lab1:
except
   BufOut:='Crete '+BufOut+' - ERROR';
end;
   for I:=1 to length(BufOut) do BufOutC[I]:=BufOut[I];
   Result:=addr(BufOutC);
end;




exports
   TestDLL name 'TestDLL',
   UsrLst name  'UsrLst',
   GetScreen name 'GetScreen';

begin
   BufOut:='';
   FillChar(BufOutC,6670,0);
end.
